<script setup lang="ts">
import { onBeforeMount, onBeforeUnmount, onMounted } from "vue";
import { useUserStore } from "@/stores/users";
import { useRouter } from "vue-router";
import { Toast } from "bootstrap";
import BootstrapToast from "@/components/BootstrapToast.vue";
import LoginButtons from "@/components/LoginButtons.vue";

const router = useRouter();

const props = defineProps<{
  returnPath?: string;
  loginError?: string;
  invitationToken?: string;
}>();

const store = useUserStore();

let errorToast: Toast | null = null;

onBeforeMount(() => {
  if (store.authenticated) {
    // If user is authenticated redirect him to the dashboard
    router.push({ name: "dashboard" });
  } else {
    const linkTag = document.createElement("link");
    linkTag.setAttribute("rel", "canonical");
    linkTag.href = window.location.origin + window.location.pathname;
    document.head.appendChild(linkTag);
  }
});

onBeforeUnmount(() => {
  document.head.querySelector("[rel=canonical]")?.remove();
});

onMounted(() => {
  errorToast = new Toast("#loginErrorToast");
  // if there is a query param 'login_error' show the error toast
  if (props.loginError) {
    errorToast?.show();
  }
});
</script>

<template>
  <bootstrap-toast toast-id="loginErrorToast" color-class="danger">
    <template #default> Login Error</template>
    <template #body>
      <p>
        There has been some kind of error during the login.<br />
        Please try again later or contact the support.
      </p>
      <p>Error Code: {{ props.loginError }}</p>
    </template>
  </bootstrap-toast>
  <div
    class="position-absolute middle-screen start-50 translate-middle text-center"
    style="min-width: 300px"
  >
    <div class="fs-3 mb-3 hide-sm">
      <img
        src="/src/assets/images/clowm.svg"
        class="mb-3 img-fluid"
        width="150"
        height="150"
        alt="CloWM Logo"
      />
      <h3>
        The <span class="clowm-blue fw-semibold">Clo</span>ud-based
        <span class="clowm-red fw-semibold">W</span>orkflow
        <span class="clowm-green fw-semibold">M</span>anager
      </h3>
    </div>
    <div class="card text-center">
      <div v-if="invitationToken" class="card-header">Invitation</div>
      <div class="card-body">
        <p v-if="invitationToken" class="card-text text-secondary">
          Connect your newly created <span class="clowm-blue fw-bold">Clo</span
          ><span class="clowm-red fw-bold">W</span
          ><span class="clowm-green fw-bold">M</span> account with
        </p>
        <p v-else class="card-text text-secondary">
          Login to <span class="clowm-blue fw-bold">Clo</span
          ><span class="clowm-red fw-bold">W</span
          ><span class="clowm-green fw-bold">M</span> via
        </p>
        <login-buttons
          :return-path="returnPath"
          :invitation-token="invitationToken"
          show-account-creation-hint
        />
      </div>
    </div>
  </div>
</template>

<style scoped>
.middle-screen {
  top: 40% !important;
}

@media (max-height: 750px) {
  .hide-sm {
    display: none !important;
  }

  .middle-screen {
    top: 50% !important;
  }
}

@media (min-height: 750px) and (max-height: 900px) {
  .middle-screen {
    top: 50% !important;
  }
}
</style>
